/*===========================================================================
/
/									ttPage
/							t@CANZX
/
/============================================================================
/ Copyright (C) 1998-2007 Sota. All rights reserved.
/
/ Redistribution and use in source and binary forms, with or without 
/ modification, are permitted provided that the following conditions 
/ are met:
/
/  1. Redistributions of source code must retain the above copyright 
/     notice, this list of conditions and the following disclaimer.
/  2. Redistributions in binary form must reproduce the above copyright 
/     notice, this list of conditions and the following disclaimer in the 
/     documentation and/or other materials provided with the distribution.
/
/ THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
/ IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
/ OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
/ IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, 
/ INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
/ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
/ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
/ ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
/ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/ THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/============================================================================*/

/* Kazuya NOGUCHI ɂC܂݂܂B */

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windowsx.h>
#include <commctrl.h>
#include <shlobj.h>
#include <tchar.h>

#include "common.h"
#include "resource.h"
#include "oniguruma.h"

/*===== vg^Cv =====*/

static void GetLongFileName(LPTSTR filename);
static void ExchangeEndian16(LPTSTR str, int size);
static void ReadCommonProc(FILEMANTBL *curFile, int topLine, int encoding, int keepSet);
#if 0
static void CheckEOLcode(FILEMANTBL *tbl);
#endif

/*===== [Jȃ[N ======*/

static FILEMANTBL *FileTblTop = NULL;
static int CurrentFile = -1;
static FILEMANTBL *CurrentTbl = NULL;

/*===== O[oȃ[N ======*/

extern int LineNum;


/*-------------------------------------------------------------------------------
Name    :	GetLongFileName
Desc    :	t@CÕtpXɕϊ
Param   :	filename	t@C
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void GetLongFileName(LPTSTR filename)
{
	LPTSTR			pos;
	LPTSTR			pos1;
	LPTSTR			set;
	_TCHAR			org[MAX_PATH+1];
	int				len;
	int				oneLen;
	HANDLE			hFind;
	WIN32_FIND_DATA	findBuf;

	/* ܂tpXɕϊ */
	GetFullPathName(filename, MAX_PATH+1, org, &pos);

	/* hCu,zXgRs[ */
	memset(filename, NUL, MAX_PATH+1);
	len = MAX_PATH;
	pos = org;
	if((pos1 = _tcschr(pos, _T(':'))) != NULL)
	{
		pos = pos1 + 1;
	}
	else if(_tcsncmp(org, _T("\\\\"), 2) == 0)
	{
		pos += 2;
		if((pos1 = _tcschr(pos, _T('\\'))) != NULL)
		{
			pos = pos1+1;
			if((pos1 = _tcschr(pos, _T('\\'))) != NULL)
			{
				pos = pos1;
			}
			else
			{
				pos = _tcschr(pos, NUL);
			}
		}
		else
		{
			pos = _tcschr(pos, NUL);
		}
	}
	len -= pos-org;
	_tcsncpy(filename, org, pos-org);

//	memcpyɂH



	/* fBNgPiRs[ */
	pos1 = _tcstok(pos, _T("\\"));
	while(pos1 != NULL)
	{
		_tcscat(filename, _T("\\"));
		set = _tcschr(filename, NUL);
		oneLen = _tcslen(pos1);
		if(len < oneLen)
		{
			break;
		}
		_tcscpy(set, pos1);

		if((hFind = FindFirstFile(filename, &findBuf)) != INVALID_HANDLE_VALUE)
		{
			FindClose(hFind);

			oneLen = _tcslen(findBuf.cFileName);
			if(len < oneLen)
			{
				break;
			}
			_tcscpy(set, findBuf.cFileName);
		}
		len -= oneLen;
		pos1 = _tcstok(NULL, _T("\\"));
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	GetLinkTarget
Desc    :	.lnkt@C̃^[Qbg擾
Param   :	hWnd		EChEnh
			filename	t@C
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void GetLinkTarget(HWND hWnd, LPTSTR filename)
{
	HRESULT			hres;
	IShellLink		*pShLink; 
	IPersistFile	*ppf;
	_TCHAR			tmp[MAX_PATH+1];

	hres = CoCreateInstance(&CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, &IID_IShellLink, (void **)&pShLink);
	if(SUCCEEDED(hres))
	{
		hres = pShLink->lpVtbl->QueryInterface(pShLink, &IID_IPersistFile, (void **)&ppf);
		if(SUCCEEDED(hres))
		{
			hres = ppf->lpVtbl->Load(ppf, filename, STGM_READ);
			if(SUCCEEDED(hres))
			{
				hres = pShLink->lpVtbl->Resolve(pShLink, hWnd, SLR_ANY_MATCH);
				if(SUCCEEDED(hres))
				{
					hres = pShLink->lpVtbl->GetPath(pShLink, tmp, MAX_PATH, NULL, 0L);
					if(SUCCEEDED(hres))
					{
						_tcscpy(filename, tmp);
					}
				}
			}
			ppf->lpVtbl->Release(ppf);
		}
		pShLink->lpVtbl->Release(pShLink);
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	AddFileData
Desc    :	t@CǗe[uǉ
Param   :	anchor		t@CǗf[^̐擪
Return  :	Xe[^X (0=)
Note    :	
-------------------------------------------------------------------------------*/
int AddFileData(FILEMANTBL **anchor)
{
	FILEMANTBL	*new;
	FILEMANTBL	*prev;
	int			ret;

	ret = -1;
	if((new = Malloc(sizeof(FILEMANTBL))) != NULL)
	{
		_tcscpy(new->Fname, _T(""));
		new->ReadFrom = READFROM_NONE;
		new->Encoding = ENCODE_AUTO;
		new->TermCode = TERM_UNKNOWN;
		new->TextDataAreaTop = NULL;
		new->TextData = NULL;
		new->TextSize = 0;
		new->TextLines = 0;
		new->LineData = NULL;
		new->AttrData = NULL;
		new->DispTopLine = 0;
		new->DispTopColumn = 0;
		new->FindStrLen = 0;
		_tcscpy(new->FindStr, _T(""));
		new->FoundTbl = NULL;
		new->RgnSelecting = NO;
		new->RgnStartPos = NULL;
		new->RgnEndPos = NULL;
		new->Next = NULL;

		ret = 0;
		if(*anchor == NULL)
		{
			*anchor = new;
		}
		else
		{
			prev = *anchor;
			ret++;
			while(prev->Next != NULL)
			{
				prev = prev->Next;
				ret++;
			}
			prev->Next = new;
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	RemoveFileData
Desc    :	t@CǗe[u폜
Param   :	anchor	t@CǗf[^̐擪
			num		f[^ԍ
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	
-------------------------------------------------------------------------------*/
int RemoveFileData(FILEMANTBL **anchor, int num)
{
	FILEMANTBL	*cur;
	FILEMANTBL	*prev;
	int			sts;

	sts = FAIL;
	if((*anchor != NULL) && (num >= 0))
	{
		sts = SUCCESS;

		cur = *anchor;
		if(num == 0)
		{
			*anchor = cur->Next;
		}
		else
		{
			for(; num > 0; num--)
			{
				prev = cur;
				cur = cur->Next;
				if(cur == NULL)
				{
					sts = FAIL;
					break;
				}
			}
			prev->Next = cur->Next;
		}

		if(sts == SUCCESS)
		{
			RemoveLineTopTbl(cur);
			CancelSearchText(cur);
			RemoveAttributeTable(cur);
			free(cur->TextDataAreaTop);
			free(cur);
		}
	}
	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	AskFileData
Desc    :	wԍ̃t@CǗf[^Ԃ
Param   :	anchor	t@CǗf[^̐擪
			num		f[^ԍ
Return  :	t@CǗf[^ (NULL=Ȃ)
Note    :	
-------------------------------------------------------------------------------*/
FILEMANTBL *AskFileData(FILEMANTBL **anchor, int num)
{
	FILEMANTBL	*ret;

	ret = NULL;
	if(num >= 0)
	{
		ret = *anchor;
		for(; num > 0; num--)
		{
			if(ret == NULL)
			{
				break;
			}
			ret = ret->Next;
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	AskCurFileTbl
Desc    :	Jgt@C̃t@CǗe[uԂ
Param   :	none
Return  :	t@CǗf[^
Note    :	
-------------------------------------------------------------------------------*/
FILEMANTBL *AskCurFileTbl(void)
{
	return(CurrentTbl);
}


/*-------------------------------------------------------------------------------
Name    :	OpenViewFromFile
Desc    :	t@Cǂݍ
Param   :	filename	t@C
			topLine		\擪sԍ (0` : -1=ŏIy[W)
			encoding	GR[fBO
			keepSet		ݒێ邩ǂ(YES/NO)
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void OpenViewFromFile(LPTSTR filename, int topLine, int encoding, int keepSet)
{
	FILE			*strm;
	long			size;
	int				tmp;
	BYTE			*buf;
	CODECONVINFO	cInfo;

	GetLinkTarget(GetMainHwnd(), filename);
	GetLongFileName(filename);

	RemoveFileData(&FileTblTop, CurrentFile);
	CurrentTbl = NULL;

	if((strm = _tfopen(filename, _T("rb"))) != NULL)
	{
		fseek(strm, 0, SEEK_END);
		size = ftell(strm);
		fseek(strm, 0, SEEK_SET);

		if((tmp = AddFileData(&FileTblTop)) != -1)
		{
			CurrentFile = tmp;
			CurrentTbl = AskFileData(&FileTblTop, CurrentFile);

			_tcscpy(CurrentTbl->Fname, filename);
			if((buf = Malloc(size)) != NULL)
			{
				if(fread(buf, 1, size, strm) == size)
				{
					if((encoding == ENCODE_AUTO) || 
					   (encoding == ENCODE_UTF16_CHECK) ||
					   (encoding == ENCODE_UTF16_BE_CHECK) ||
					   (encoding == ENCODE_UTF8_CHECK))
					{
						CurrentTbl->Encoding = CheckEncoding(buf, size, encoding);
					}
					else
					{
						CurrentTbl->Encoding = encoding;
					}

					switch(CurrentTbl->Encoding)
					{
						case ENCODE_SJIS :
						default :
							/* Shift-JIS */
							CurrentTbl->TextSize = MultiByteToWideChar(CP_OEMCP, 0, buf, size, NULL, 0);
							CurrentTbl->TextDataAreaTop = Malloc(CurrentTbl->TextSize * sizeof(_TCHAR));
							MultiByteToWideChar(CP_OEMCP, 0, buf, size, (LPTSTR)CurrentTbl->TextDataAreaTop, CurrentTbl->TextSize);
							CurrentTbl->TextData = (LPTSTR)CurrentTbl->TextDataAreaTop;
							free((char*)buf);
							break;

						case ENCODE_JIS :
							/* JIS */
							/* JIS to Shift-JIS */
							cInfo.OrgStr = buf;
							cInfo.OrgLen = size;
							ConvJIStoSJIS(&cInfo);
							free(buf);

							/* Shift-JIS to UTF16 */
							CurrentTbl->TextSize = MultiByteToWideChar(CP_OEMCP, 0, cInfo.Str, cInfo.Len, NULL, 0);
							CurrentTbl->TextDataAreaTop = Malloc(CurrentTbl->TextSize * sizeof(_TCHAR));
							MultiByteToWideChar(CP_OEMCP, 0, cInfo.Str, cInfo.Len, (LPTSTR)CurrentTbl->TextDataAreaTop, CurrentTbl->TextSize);
							CurrentTbl->TextData = (LPTSTR)CurrentTbl->TextDataAreaTop;
							free(cInfo.Str);
							break;

						case ENCODE_EUC :
							/* EUC */
							/* EUC to Shift-JIS */
							cInfo.OrgStr = buf;
							cInfo.OrgLen = size;
							ConvEUCtoSJIS(&cInfo);
							free(buf);

							/* Shift-JIS to UTF16 */
							CurrentTbl->TextSize = MultiByteToWideChar(CP_OEMCP, 0, cInfo.Str, cInfo.Len, NULL, 0);
							CurrentTbl->TextDataAreaTop = Malloc(CurrentTbl->TextSize * sizeof(_TCHAR));
							MultiByteToWideChar(CP_OEMCP, 0, cInfo.Str, cInfo.Len, (LPTSTR)CurrentTbl->TextDataAreaTop, CurrentTbl->TextSize);
							CurrentTbl->TextData = (LPTSTR)CurrentTbl->TextDataAreaTop;
							free(cInfo.Str);
							break;

						case ENCODE_UTF16_BOM :
							/* UTF-16 with BOM */
							CurrentTbl->TextSize = (size - 2) / sizeof(_TCHAR);
							CurrentTbl->TextDataAreaTop = buf;
							CurrentTbl->TextData = (LPTSTR)(buf + 2);
							break;

						case ENCODE_UTF16_BOM_BE :
							/* UTF-16 with BOM (Big Endian) */
							CurrentTbl->TextSize = (size - 2) / sizeof(_TCHAR);
							CurrentTbl->TextDataAreaTop = buf;
							CurrentTbl->TextData = (LPTSTR)(buf + 2);
							ExchangeEndian16(CurrentTbl->TextData, CurrentTbl->TextSize);
							break;

						case ENCODE_UTF16_NOBOM :
							/* UTF-16 without BOM */
							CurrentTbl->TextSize = size / sizeof(_TCHAR);
							CurrentTbl->TextDataAreaTop = buf;
							CurrentTbl->TextData = (LPTSTR)buf;
							break;

						case ENCODE_UTF16_NOBOM_BE :
							/* UTF-16 without BOM (Big Endian) */
							CurrentTbl->TextSize = size / sizeof(_TCHAR);
							CurrentTbl->TextDataAreaTop = buf;
							CurrentTbl->TextData = (LPTSTR)buf;
							ExchangeEndian16(CurrentTbl->TextData, CurrentTbl->TextSize);
							break;

						case ENCODE_UTF8_BOM :
							/* UTF-8 with BOM */
							CurrentTbl->TextSize = MultiByteToWideChar(CP_UTF8, 0, buf+3, size-3, NULL, 0);
							CurrentTbl->TextDataAreaTop = Malloc(CurrentTbl->TextSize * sizeof(_TCHAR));
							MultiByteToWideChar(CP_UTF8, 0, buf+3, size-3, (LPTSTR)CurrentTbl->TextDataAreaTop, CurrentTbl->TextSize);
							CurrentTbl->TextData = (LPTSTR)CurrentTbl->TextDataAreaTop;
							free(buf);
							break;

						case ENCODE_UTF8_NOBOM :
							/* UTF-8 without BOM */
							CurrentTbl->TextSize = MultiByteToWideChar(CP_UTF8, 0, buf, size, NULL, 0);
							CurrentTbl->TextDataAreaTop = Malloc(CurrentTbl->TextSize * sizeof(_TCHAR));
							MultiByteToWideChar(CP_UTF8, 0, buf, size, (LPTSTR)CurrentTbl->TextDataAreaTop, CurrentTbl->TextSize);
							CurrentTbl->TextData = (LPTSTR)CurrentTbl->TextDataAreaTop;
							free(buf);
							break;

						case ENCODE_UTF7_NOBOM :
							/* UTF-7 */
							CurrentTbl->TextSize = MultiByteToWideChar(CP_UTF7, 0, buf, size, NULL, 0);
							CurrentTbl->TextDataAreaTop = Malloc(CurrentTbl->TextSize * sizeof(_TCHAR));
							MultiByteToWideChar(CP_UTF7, 0, buf, size, (LPTSTR)CurrentTbl->TextDataAreaTop, CurrentTbl->TextSize);
							CurrentTbl->TextData = (LPTSTR)CurrentTbl->TextDataAreaTop;
							free(buf);
							break;
					}

					CurrentTbl->TermCode = CheckTerminationCode(CurrentTbl->TextData, CurrentTbl->TextSize);
					CurrentTbl->ReadFrom = READFROM_FILE;
				}
				else
				{
					// t@Cǂݍ݃G[
				}
			}
		}
		fclose(strm);

		AddFileToHistory(filename);
	}
	ReadCommonProc(CurrentTbl, topLine, encoding, keepSet);
	return;
}


/*-------------------------------------------------------------------------------
Name    :	ExchangeEndian16
Desc    :	16rbgPʂŃGfBAύX
Param   :	str		
			size	oCg
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void ExchangeEndian16(LPTSTR str, int size)
{
	BYTE	*pos;
	BYTE	ch;

	pos = (BYTE*)str;
	for(; size > 0; size--)
	{
		ch = *pos;
		*pos = *(pos+1);
		*(pos+1) = ch;
		pos += 2;
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	ReopenViewFromFile
Desc    :	t@C̍ēǂݍ
Param   :	encoding	GR[h̎
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void ReopenViewFromFile(int encoding)
{
	_TCHAR	filename[MAX_PATH+1];
	int		num;

	if(CurrentTbl->ReadFrom == READFROM_FILE)
	{
		CurrentTbl = AskFileData(&FileTblTop, CurrentFile);
		_tcscpy(filename, CurrentTbl->Fname);
		num = CurrentTbl->DispTopLine;
		if(AskCurExtSet()->LineNumType == LINENUM_EDITOR)
		{
			num = GetLogicalLineNum(CurrentTbl, num);
		}
		OpenViewFromFile(filename, num, encoding, YES);
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	OpenViewFromClipBoard
Desc    :	Nbv{[hǂݍ
Param   :	topLine		\擪sԍ (0` : -1=ŏIy[W)
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void OpenViewFromClipBoard(int topLine)
{
	HGLOBAL	cbhdl;
	LPTSTR	data;
	int		size;
	int		tmp;

	RemoveFileData(&FileTblTop, CurrentFile);
	CurrentTbl = NULL;

	if(OpenClipboard(GetMainHwnd()))
	{
		if((cbhdl = GetClipboardData(CF_UNICODETEXT)) != NULL)
		{
			if((data = GlobalLock(cbhdl)) != NULL)
			{
				size = _tcslen(data);
				if((tmp = AddFileData(&FileTblTop)) != -1)
				{
					CurrentFile = tmp;
					CurrentTbl = AskFileData(&FileTblTop, CurrentFile);

					_tcscpy(CurrentTbl->Fname, MSGJPN_5);
					if((CurrentTbl->TextDataAreaTop = Malloc(size * sizeof(_TCHAR)/* + BUFFER_MARGIN*/)) != NULL)
					{
						CurrentTbl->TextSize = size;
						CurrentTbl->TextData = (LPTSTR)CurrentTbl->TextDataAreaTop;
						memcpy(CurrentTbl->TextData, data, size * sizeof(_TCHAR));

						CurrentTbl->ReadFrom = READFROM_CBOARD;
					}
				}
				GlobalUnlock(cbhdl);
			}
		}
		CloseClipboard();
	}
	ReadCommonProc(CurrentTbl, topLine, ENCODE_AUTO, NO);
	return;
}


/*-------------------------------------------------------------------------------
Name    :	OpenViewFromStdin
Desc    :	W͂ǂݍ
Param   :	topLine		\擪sԍ (0` : -1=ŏIy[W)
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void OpenViewFromStdin(int topLine)
{
	BYTE	buf[1024];
	BYTE	*oemText;
	int		size;
	int		readSize;
	int		zeroCount;
	HANDLE	*hStdin;
	LPTSTR	text;
	int		tmp;

	RemoveFileData(&FileTblTop, CurrentFile);
	CurrentTbl = NULL;

	readSize = 0;
	if((hStdin = GetStdHandle(STD_INPUT_HANDLE)) != INVALID_HANDLE_VALUE)
	{
		ReadFile(hStdin, buf, 1024, &readSize, NULL);
	}

	if(readSize > 0)
	{
		if((oemText = Malloc(readSize/* + BUFFER_MARGIN*/)) != NULL)
		{
			/* ȉƉ */
			zeroCount = 2;
			memcpy(oemText, buf, readSize);
			size = readSize;
			while(zeroCount > 0)
			{
				ReadFile(hStdin, buf, 1024, &readSize, NULL);
				if(readSize > 0)
				{
					if((oemText = Realloc(oemText, size + readSize/* + BUFFER_MARGIN*/)) != NULL)
					{
						memcpy(oemText + size, buf, readSize);
						size += readSize;
					}
				}
				else
				{
					zeroCount--;
				}
			}

			{
				int tmp1 = MultiByteToWideChar(CP_OEMCP, 0, oemText, size, NULL, 0);
				LPTSTR tmp2 = Malloc(tmp1 * sizeof(_TCHAR));
				MultiByteToWideChar(CP_OEMCP, 0, oemText, size, tmp2, tmp1);
				free(oemText);
				text = tmp2;
				size = tmp1;
			}
		}

		if(text != NULL)
		{
			if((tmp = AddFileData(&FileTblTop)) != -1)
			{
				CurrentFile = tmp;
				CurrentTbl = AskFileData(&FileTblTop, CurrentFile);

				_tcscpy(CurrentTbl->Fname, MSGJPN_5);
				CurrentTbl->TextSize = size;
				CurrentTbl->TextDataAreaTop = (BYTE*)text;
				CurrentTbl->TextData = text;
				CurrentTbl->ReadFrom = READFROM_STDIN;
			}
			else
			{
				free(text);
			}
		}
	}
	ReadCommonProc(CurrentTbl, topLine, ENCODE_AUTO, NO);
	return;
}


/*-------------------------------------------------------------------------------
Name    :	ReadCommonProc
Desc    :	Ǎ̋ʏ
Param   :	curFile		t@CǗe[u
			topLine		\擪sԍ (0` : -1=ŏIy[W)
			encoding	GR[fBO (ENCODE_xxx)
			keepSet		ݒێ邩ǂ(YES/NO)
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void ReadCommonProc(FILEMANTBL *curFile, int topLine, int encoding, int keepSet)
{
	_TCHAR	buf[MAX_PATH+11];

	if(curFile != NULL)
	{
		if(curFile->TextSize > 0)
		{
			DispFileInfo(curFile->Fname);
			DispEncoding(curFile->Encoding);
			DispTerminationCode(curFile->TermCode);

			ExitAllEditor(NO);

#if 0
			CheckEOLcode(curFile);
#endif

			MakeAttributeTable(curFile);
		}

		if(keepSet == NO)
		{
			SetCurExtNum();
		}
		LineNum = AskCurExtSet()->LineNumDisp;
		SetFontSize();
		SetCellSize();
		/* E[Ő܂ԂResizeViewWindow()MakeLineTopTbl()s */
		if(AskCurExtSet()->FoldRight == NO)
		{
			MakeLineTopTbl(curFile);
		}
		CalcLineNumWinWidth();
		ResizeNumWindow();
		ResizeViewWindow();
		SetWindowSize();
		SetScrollBar();
		SetViewBackColor(AskCurExtSet()->BackColor);

		if(topLine == -1)
		{
			SendMessage(GetViewWinHwnd(), WM_COMMAND, MAKEWPARAM(MENU_FILEBTM, 0), 0);
		}
		else
		{
			SendMessage(GetViewWinHwnd(), WM_CHANGE_TOP, 0, topLine);
		}
		DispCurrentLineNum(STATUS_WIN_TOP_LINE_NUM, curFile->DispTopLine);
		DispMousePos();

//Kazuya NOGUCHI: t@CpX̕\؂ւΉ: start
		/* ANeBu̎ */
		if( (GetActiveWindow() != GetMainHwnd()) )
		{
			LPTSTR sFname ;

			sFname = _tcsrchr(curFile->Fname,_T('\\')) ;
			_stprintf(buf, _T("%s - ttPage"), sFname ? sFname+1 : curFile->Fname ) ;
		}
		/* ANeBu̎ */
		else
		{
			_stprintf(buf, _T("%s - ttPage"), curFile->Fname);
		}
//Kazuya NOGUCHI: t@CpX̕\؂ւΉ: end

		SendMessage(GetMainHwnd(), WM_SETTEXT, 0, (LPARAM)buf);
	}
	else
	{
		SendMessage(GetMainHwnd(), WM_SETTEXT, 0, (LPARAM)_T("ttPage"));
	}
	InvalidateRgn(GetNumWinHwnd(), NULL, TRUE);
	InvalidateRgn(GetViewWinHwnd(), NULL, TRUE);
	return;
}

#if 0
/*----- sR[h̃`FbN ----------------------------------------------
*
*	Parameter
*		FILEMANTBL *tbl : t@CǗe[u
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void CheckEOLcode(FILEMANTBL *tbl)
{
	LPTSTR		text;
	LPTSTR		btm;
	int			size;

	text = tbl->TextData;
	size = tbl->TextSize;
	btm = text + size;
	while((text != NULL) && (text < btm))
	{
		if((text = memchr(text, _T('\r'), (BYTE*)btm-(BYTE*)text)) != NULL)
		{
			if((text+1 >= btm) || (*(text+1) != _T('\n')))
			{
				*text = _T('\n');
			}
			else
			{
				memmove(text, text+1, btm-(text+1));
				btm--;
				size--;
			}
		}
	}
	tbl->TextSize = size;
	return;
}
#endif






