/*===========================================================================
/
/									ttPage
/							Xe[^XEChE
/
/============================================================================
/ Copyright (C) 1998-2007 Sota. All rights reserved.
/
/ Redistribution and use in source and binary forms, with or without 
/ modification, are permitted provided that the following conditions 
/ are met:
/
/  1. Redistributions of source code must retain the above copyright 
/     notice, this list of conditions and the following disclaimer.
/  2. Redistributions in binary form must reproduce the above copyright 
/     notice, this list of conditions and the following disclaimer in the 
/     documentation and/or other materials provided with the distribution.
/
/ THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
/ IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
/ OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
/ IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, 
/ INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
/ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
/ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
/ ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
/ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/ THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/============================================================================*/

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windowsx.h>
#include <commctrl.h>
#include <tchar.h>

#include "common.h"
#include "resource.h"

/*===== [Jȃ[N =====*/

static int SbarColWidth[] = { 110, 160, 270, 380, -1 };
static HWND hWndSbar = NULL;


/*-------------------------------------------------------------------------------
Name    :	MakeStatusWindow
Desc    :	Xe[^XEChE쐬
Param   :	hWnd	eEChẼEChEnh
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	
-------------------------------------------------------------------------------*/
int MakeStatusWindow(HWND hWnd)
{
	int		sts;

	sts = FAIL;
	hWndSbar = CreateWindowEx(0,
			STATUSCLASSNAME, NULL,
			WS_CHILD | WS_CLIPSIBLINGS | SBARS_SIZEGRIP,
			0, 0, 0, 0,
			hWnd, (HMENU)1500, GetProgInst(), NULL);

	if(hWndSbar != NULL)
	{
		SendMessage(hWndSbar, SB_SETPARTS, sizeof(SbarColWidth)/sizeof(int), (LPARAM)SbarColWidth);
		ShowWindow(hWndSbar, SW_SHOW);
		sts = SUCCESS;
	}
	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	GetStatusWinHwnd
Desc    :	Xe[^XEChẼEChEnhԂ
Param   :	none
Return  :	EChEnh
Note    :	
-------------------------------------------------------------------------------*/
HWND GetStatusWinHwnd(void)
{
	return(hWndSbar);
}


/*-------------------------------------------------------------------------------
Name    :	GetStatusWinHeight
Desc    :	Xe[^XEChE̍Ԃ
Param   :	none
Return  :	EChE̍
Note    :	
-------------------------------------------------------------------------------*/
int GetStatusWinHeight(void)
{
	RECT	rect;

	rect.bottom = 0;
	if(hWndSbar != NULL)
	{
		GetClientRect(hWndSbar, &rect);
	}
	return(rect.bottom);
}


/*-------------------------------------------------------------------------------
Name    :	ResizeStatusWin
Desc    :	Xe[^XEChẼTCYύX̏
Param   :	none
Return  :	none
Note    :	CEChEc[o[^Xe[^Xo[r[EChȄ
			TCYύX邱
-------------------------------------------------------------------------------*/
void ResizeStatusWin(void)
{
	RECT	rect;

	if(hWndSbar != NULL)
	{
		GetClientRect(GetMainHwnd(), &rect);
		SendMessage(hWndSbar, WM_SIZE, SIZE_RESTORED, MAKELPARAM(rect.right, rect.bottom));
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	DispEncoding
Desc    :	R[h̎ނ\
Param   :	encoding	GR[fBO (ENCODE_xxx)
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void DispEncoding(int encoding)
{
	LPTSTR	str;

	switch(encoding)
	{
		case ENCODE_SJIS :
			str = _T("SHIFT-JIS");
			break;

		case ENCODE_JIS :
			str = _T("JIS");
			break;

		case ENCODE_EUC :
			str = _T("EUC");
			break;

		case ENCODE_UTF16_BOM :
			str = _T("UTF16(BOM)");
			break;

		case ENCODE_UTF16_BOM_BE :
			str = _T("UTF16(BOM)(BE)");
			break;

		case ENCODE_UTF16_NOBOM :
			str = _T("UTF16");
			break;

		case ENCODE_UTF16_NOBOM_BE :
			str = _T("UTF16(BE)");
			break;

		case ENCODE_UTF8_BOM :
			str = _T("UTF8(BOM)");
			break;

		case ENCODE_UTF8_NOBOM :
			str = _T("UTF8");
			break;

		case ENCODE_UTF7_NOBOM :
			str = _T("UTF7");
			break;

		default :
			str = _T("");
			break;
	}

	SendMessage(hWndSbar, SB_SETTEXT, STATUS_WIN_ENCODE | 0, (LPARAM)str);
	SetEncodingMenu(encoding);

	return;
}


/*-------------------------------------------------------------------------------
Name    :	DispTerminationCode
Desc    :	sR[h\
Param   :	term	sR[h̎ (TERM_xxx)
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void DispTerminationCode(int term)
{
	LPTSTR	str;

	switch(term)
	{
		case TERM_CRLF :
			str = _T("CR-LF");
			break;

		case TERM_LF :
			str = _T("LF");
			break;

		case TERM_CR :
			str = _T("CR");
			break;

		default :
			str = _T("");
			break;
	}

	SendMessage(hWndSbar, SB_SETTEXT, STATUS_WIN_TERMINATION_CODE | 0, (LPARAM)str);

	return;
}


/*-------------------------------------------------------------------------------
Name    :	DispCurrentLineNum
Desc    :	sԍ\
Param   :	pos		\ʒu
			num		sԍ
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void DispCurrentLineNum(int pos, int num)
{
	_TCHAR		buf[40];
	FILEMANTBL	*CurFile;

	_tcscpy(buf, _T(""));
	if((CurFile = AskCurFileTbl()) != NULL)
	{
		if(AskCurExtSet()->LineNumType == LINENUM_WP)
		{
			num = num + 1;
		}
		else
		{
			num = GetLogicalLineNum(CurFile, num) + 1;
		}

		if(num <= 0)
		{
			_stprintf(buf, _T("-----"));
		}
		else
		{
			if(pos == STATUS_WIN_TOP_LINE_NUM)
			{
				_stprintf(buf, MSGJPN_34, num);
			}
			else
			{
				_stprintf(buf, MSGJPN_35, num);
			}
		}
	}
	SendMessage(hWndSbar, SB_SETTEXT, pos | 0, (LPARAM)buf);

	return;
}


/*-------------------------------------------------------------------------------
Name    :	DispFileInfo
Desc    :	t@C\
Param   :	Fname	t@C
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void DispFileInfo(LPTSTR Fname)
{
	_TCHAR			buf[MAX_PATH+33];
	HANDLE			hFind;
	WIN32_FIND_DATA	findBuf;
	SYSTEMTIME		sTime;
	FILETIME		fTime;

	_tcscpy(buf, _T(""));
	if(Fname != NULL)
	{
		if((hFind = FindFirstFile(Fname, &findBuf)) != INVALID_HANDLE_VALUE)
		{
			FileTimeToLocalFileTime(&findBuf.ftLastWriteTime, &fTime);
			FileTimeToSystemTime(&fTime, &sTime);
			_stprintf(buf, _T("%04d/%02d/%02d %2d:%02d   %d Bytes"), 
				sTime.wYear, sTime.wMonth, sTime.wDay, sTime.wHour, sTime.wMinute, findBuf.nFileSizeLow);
			FindClose(hFind);
		}
	}
	SendMessage(hWndSbar, SB_SETTEXT, STATUS_WIN_FILE_INFO | 0, (LPARAM)buf);

	return;
}


